/****************************************/
/* Cool Herders                         */
/* A demented muse by Brendan Wiese     */
/* http://starbow.org                   */
/* Programmed by Mike Brent             */
/* http://tursi.yiffco.com              */
/* rand.c                               */
/****************************************/

/* Thanks to Albert Veli for this clever routine! */

#define MASK 0xa3000000		// 32 bit random number

unsigned int seed __attribute__ ((aligned(4))) = 1;

void srand(unsigned long newseed)
{
	if (newseed) {
		seed=newseed;
	} else {
		seed=1;
	}
}

// Will return a semi-random value - returns each possible number only once
// before repeating! Can never return 0, however.
int rand()
{
	if(seed & 1){ /* If the bit shifted out is a 1, perform the xor */
		seed >>= 1;
		seed ^= MASK;
	}
	else { /* Else just shift */
		seed >>= 1;
	}
	
	return(seed);
}
